<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>physicallayer/network.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">physicallayer/network.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2005 by Christian Van Brussel</span>
<a name="l00004"></a>00004 <span class="comment"></span>
<a name="l00005"></a>00005 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment">    Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00016"></a>00016 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00017"></a>00017 <span class="comment">    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.</span>
<a name="l00018"></a>00018 <span class="comment">*/</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __CEL_PL_NETWORK__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_PL_NETWORK__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cstypes_8h.html">cstypes.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/scf_8h.html">csutil/scf.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/csutil_2strset_8h.html">csutil/strset.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="keyword">struct </span><a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>;
<a name="l00028"></a>00028 <span class="keyword">struct </span><a class="code" href="structiCelDataBuffer.html" title="This interface describes persistable data.">iCelDataBuffer</a>;
<a name="l00029"></a>00029 <span class="keyword">enum</span> celNetworkGameType;
<a name="l00030"></a>00030 <span class="keyword">enum</span> celServerNetworkState;
<a name="l00031"></a>00031 <span class="keyword">enum</span> celPlayerNetworkState;
<a name="l00032"></a>00032 <span class="keyword">struct </span>celGame;
<a name="l00033"></a>00033 <span class="keyword">class </span><a class="code" href="classcelGameInfo.html" title="General information on a game.">celGameInfo</a>;
<a name="l00034"></a>00034 <span class="keyword">class </span><a class="code" href="classcelPlayer.html" title="General information on a player.">celPlayer</a>;
<a name="l00035"></a>00035 <span class="keyword">struct </span><a class="code" href="structiCelPlayerList.html" title="A list of players.">iCelPlayerList</a>;
<a name="l00036"></a>00036 <span class="keyword">class </span><a class="code" href="classcelServerEventData.html" title="The data about a server event.">celServerEventData</a>;
<a name="l00037"></a>00037 <span class="keyword">class </span><a class="code" href="classcelClientEventData.html" title="The data about a client event.">celClientEventData</a>;
<a name="l00038"></a>00038 <span class="keyword">class </span><a class="code" href="classcelNetworkLinkData.html" title="The data about a network link.">celNetworkLinkData</a>;
<a name="l00039"></a>00039 <span class="keyword">class </span><a class="code" href="classcelGameFactoryManager.html" title="This is an interface you should implement in order to manage the events from the factory of game sess...">celGameFactoryManager</a>;
<a name="l00040"></a>00040 <span class="keyword">class </span><a class="code" href="classcelGameClientManager.html" title="This is an interface you should implement in order to manage the events from the client.">celGameClientManager</a>;
<a name="l00041"></a>00041 <span class="keyword">class </span><a class="code" href="classcelGameServerManager.html" title="This is an interface you should implement in order to manage the events from the server.">celGameServerManager</a>;
<a name="l00042"></a>00042 <span class="keyword">struct </span><a class="code" href="structcelNetworkServerStats.html" title="The network stats of the connection viewed by the client.">celNetworkServerStats</a>;
<a name="l00043"></a>00043 <span class="keyword">struct </span><a class="code" href="structcelNetworkPlayerStats.html" title="The network stats of the connection viewed by the server.">celNetworkPlayerStats</a>;
<a name="l00044"></a>00044 <span class="keyword">struct </span>celNetworkServerTotalStats;
<a name="l00045"></a>00045 
<a name="l00050"></a><a class="code" href="structiCelGame.html">00050</a> <span class="keyword">struct </span><a class="code" href="structiCelGame.html" title="A networked game.">iCelGame</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052   SCF_INTERFACE (<a class="code" href="structiCelGame.html" title="A networked game.">iCelGame</a>, 0, 0, 1);
<a name="l00053"></a>00053 
<a name="l00057"></a>00057   <span class="keyword">virtual</span> celNetworkGameType <a class="code" href="structiCelGame.html#af5f0c41b23620076dd4603619f814041" title="Return the type of the game.">GetGameType</a> () <span class="keyword">const</span> = 0;
<a name="l00058"></a>00058 
<a name="l00062"></a>00062   <span class="keyword">virtual</span> <a class="code" href="classcelGameInfo.html" title="General information on a game.">celGameInfo</a>* <a class="code" href="structiCelGame.html#a1d382192880b9c9ef9d869aefa919ede" title="Return the general info of the game.">GetGameInfo</a> () = 0;
<a name="l00063"></a>00063 
<a name="l00068"></a>00068   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelGame.html#a993f6c7640971383007b0f52fc2b0d0a" title="Return true if a local server is available in this process, false otherwise.">IsServerAvailable</a> () <span class="keyword">const</span> = 0;
<a name="l00069"></a>00069 
<a name="l00073"></a>00073   <span class="keyword">virtual</span> <a class="code" href="structiCelGameServer.html" title="The main object to manage the server game logic.">iCelGameServer</a>* <a class="code" href="structiCelGame.html#a985179a654afc7d9d16d5ff5e5a4fb2f" title="Return the local server if available, 0 otherwise.">GetGameServer</a> () <span class="keyword">const</span> = 0;
<a name="l00074"></a>00074 
<a name="l00079"></a>00079   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelGame.html#a684f6884e90593d9bbadd86a1104fe8a" title="Return true if a local client is available in this process, false otherwise.">IsClientAvailable</a> () <span class="keyword">const</span> = 0;
<a name="l00080"></a>00080 
<a name="l00084"></a>00084   <span class="keyword">virtual</span> <a class="code" href="structiCelGameClient.html" title="The main object to manage the client game logic.">iCelGameClient</a>* <a class="code" href="structiCelGame.html#a6e9f791b54a7f2bfff6babbf004ff3a3" title="Return the local client if available, 0 otherwise.">GetGameClient</a> () <span class="keyword">const</span> = 0;
<a name="l00085"></a>00085 };
<a name="l00086"></a>00086 
<a name="l00098"></a><a class="code" href="structiCelGameFactory.html">00098</a> <span class="keyword">struct </span><a class="code" href="structiCelGameFactory.html" title="A factory to manage game sessions.">iCelGameFactory</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00099"></a>00099 {
<a name="l00100"></a>00100   SCF_INTERFACE (<a class="code" href="structiCelGameFactory.html" title="A factory to manage game sessions.">iCelGameFactory</a>, 1, 0, 0);
<a name="l00101"></a>00101 
<a name="l00108"></a>00108   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameFactory.html#ad9f141fd1a3d38edcc6b911adb9ea623" title="Set the name of the game.">SetGameName</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* game_name) = 0;
<a name="l00109"></a>00109 
<a name="l00114"></a>00114   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structiCelGameFactory.html#a3997882a6993353c13208c58df38c928" title="Return the name of the game.">GetGameName</a> () <span class="keyword">const</span> = 0;
<a name="l00115"></a>00115 
<a name="l00128"></a>00128   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameFactory.html#a4c123a0d396bb31715ad21eb53221275" title="Set the name of the network protocol version used by this application.">SetProtocolVersion</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* protocol_version) = 0;
<a name="l00129"></a>00129 
<a name="l00135"></a>00135   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structiCelGameFactory.html#a0d070b19ad4886d753dd44446eed2397" title="Return the network protocol version used by this application.">GetProtocolVersion</a> () <span class="keyword">const</span> = 0;
<a name="l00136"></a>00136 
<a name="l00143"></a>00143   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameFactory.html#acaf75baa0e49d7db41856abb3f3929db" title="Register a manager for this game factory.">RegisterGameFactoryManager</a>
<a name="l00144"></a>00144     (<a class="code" href="classcelGameFactoryManager.html" title="This is an interface you should implement in order to manage the events from the factory of game sess...">celGameFactoryManager</a>* manager) = 0;
<a name="l00145"></a>00145 
<a name="l00155"></a>00155   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameFactory.html#a7756c198de88c4b38ad29199dd92e1ca" title="Start to search for the list of available games with the same game name, protocol version and game ty...">StartSearchForGameList</a> (celNetworkGameType game_type, 
<a name="l00156"></a>00156         <a class="code" href="classcelGameInfo.html" title="General information on a game.">celGameInfo</a>* filter = 0) = 0;
<a name="l00157"></a>00157 
<a name="l00162"></a>00162   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameFactory.html#a22f040f0344983d25ebe5c1eeb9b8371" title="Stop searching for the list of available games.">StopSearchForGameList</a> () = 0;
<a name="l00163"></a>00163 
<a name="l00167"></a>00167   <span class="keyword">virtual</span> <a class="code" href="structiCelGame.html" title="A networked game.">iCelGame</a>* <a class="code" href="structiCelGameFactory.html#a08d9669ad5b464d602b3c31365f6ae0c" title="Return the current game or 0 if no game is available.">GetCurrentGame</a> () <span class="keyword">const</span> = 0;
<a name="l00168"></a>00168 
<a name="l00182"></a>00182   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelGameFactory.html#ab250a31bae2353686a1a86c0133b9717" title="Create a new game, ie at least a server, but also a client if a player is provided.">CreateNewGame</a> (celNetworkGameType game_type, 
<a name="l00183"></a>00183         <a class="code" href="classcelGameInfo.html" title="General information on a game.">celGameInfo</a>* game_info, <a class="code" href="classcelPlayer.html" title="General information on a player.">celPlayer</a>* player = 0) = 0;
<a name="l00184"></a>00184 
<a name="l00197"></a>00197   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelGameFactory.html#a47864202511ee8b1b082a713d6160160" title="Connect the player to the game specified in game_info.">ConnectGame</a> (<a class="code" href="classcelGameInfo.html" title="General information on a game.">celGameInfo</a>* game_info, 
<a name="l00198"></a>00198         <a class="code" href="classcelPlayer.html" title="General information on a player.">celPlayer</a>* player) = 0;
<a name="l00199"></a>00199 
<a name="l00205"></a>00205   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelGameFactory.html#a2c05f2035c8b36890cc1b054ffaddf79" title="The player leaves the current game or playback.">CloseGame</a> () = 0;
<a name="l00206"></a>00206 
<a name="l00210"></a>00210   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameFactory.html#a9d5996c57a9c498fffdf27cf9acb9cb1" title="Incoming events are recorded in a file.">StartRecordingGame</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* filename) = 0;
<a name="l00211"></a>00211 
<a name="l00215"></a>00215   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameFactory.html#ac9e2167e6cf65890342941d91a0c5481" title="Incoming events are no more recorded in a file.">StopRecordingGame</a> () = 0;
<a name="l00216"></a>00216 
<a name="l00223"></a>00223   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameFactory.html#a3994903c1501277c80ef87f66593eac5" title="Start a game where incoming events are read from a file from start_time to stop_time.">StartPlayBackGame</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* filename, 
<a name="l00224"></a>00224         <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> start_time, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> stop_time) = 0;
<a name="l00225"></a>00225 };
<a name="l00226"></a>00226 
<a name="l00237"></a><a class="code" href="classcelGameFactoryManager.html">00237</a> <span class="keyword">class </span><a class="code" href="classcelGameFactoryManager.html" title="This is an interface you should implement in order to manage the events from the factory of game sess...">celGameFactoryManager</a>
<a name="l00238"></a>00238 {
<a name="l00239"></a>00239 <span class="keyword">public</span>:
<a name="l00240"></a>00240   <span class="keyword">virtual</span> ~<a class="code" href="classcelGameFactoryManager.html" title="This is an interface you should implement in order to manage the events from the factory of game sess...">celGameFactoryManager</a> () {}
<a name="l00241"></a>00241 
<a name="l00250"></a><a class="code" href="classcelGameFactoryManager.html#a39c1ea28335081be506112b125b924b2">00250</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classcelGameFactoryManager.html#a39c1ea28335081be506112b125b924b2" title="The game factory is searching for available games (it has been started with iCelGameFactory::StartSea...">GameInfoReceived</a> (<a class="code" href="classcelGameInfo.html" title="General information on a game.">celGameInfo</a>* game_info, 
<a name="l00251"></a>00251         <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> server_latency) {}
<a name="l00252"></a>00252 
<a name="l00268"></a>00268   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classcelGameFactoryManager.html#a725d679aa5ef5845a020476038d85ee1" title="The state of the network connection from the client to the server has changed.">ServerNetworkStateChanged</a> (celServerNetworkState new_state, 
<a name="l00269"></a>00269         celServerNetworkState previous_state, <span class="keyword">const</span> <span class="keywordtype">char</span>* reason = <span class="stringliteral">&quot;&quot;</span>) = 0;
<a name="l00270"></a>00270 
<a name="l00282"></a><a class="code" href="classcelGameFactoryManager.html#ab2b906cb592b493f0563221e4238333f">00282</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classcelGameFactoryManager.html#ab2b906cb592b493f0563221e4238333f" title="A client is created and has to be initialized.">InitClient</a> (<a class="code" href="structiCelGame.html" title="A networked game.">iCelGame</a>* game) { <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00283"></a>00283 
<a name="l00291"></a><a class="code" href="classcelGameFactoryManager.html#abef391e780d2a9874f70a674cf8b741a">00291</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classcelGameFactoryManager.html#abef391e780d2a9874f70a674cf8b741a" title="A server is created and has to be initialized.">InitServer</a> (<a class="code" href="structiCelGame.html" title="A networked game.">iCelGame</a>* game) { <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00292"></a>00292 
<a name="l00301"></a><a class="code" href="classcelGameFactoryManager.html#a988219ab5ffebdadbc1b91ea4f29eda5">00301</a>   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;iCelDataBuffer&gt;</a> <a class="code" href="classcelGameFactoryManager.html#a988219ab5ffebdadbc1b91ea4f29eda5" title="Return the baseline of a client event.">GetClientEventBaseline</a> (
<a name="l00302"></a>00302         celClientEventType event_type) { <span class="keywordflow">return</span> 0; }
<a name="l00303"></a>00303 
<a name="l00309"></a><a class="code" href="classcelGameFactoryManager.html#ae05afe2920598098eeccb26327aea192">00309</a>   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;iCelDataBuffer&gt;</a> <a class="code" href="classcelGameFactoryManager.html#ae05afe2920598098eeccb26327aea192" title="Return the baseline of a server event.">GetServerEventBaseline</a> (
<a name="l00310"></a>00310         celServerEventType event_type) { <span class="keywordflow">return</span> 0; }
<a name="l00311"></a>00311 
<a name="l00317"></a><a class="code" href="classcelGameFactoryManager.html#a1b0660f3f2c949f4c8df6af2053707dd">00317</a>   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;iCelDataBuffer&gt;</a> <a class="code" href="classcelGameFactoryManager.html#a1b0660f3f2c949f4c8df6af2053707dd" title="Return the baseline of a network link.">GetNetworkLinkBaseline</a> (
<a name="l00318"></a>00318         celNetworkLinkType link_type) { <span class="keywordflow">return</span> 0; }
<a name="l00319"></a>00319 
<a name="l00320"></a>00320 };
<a name="l00321"></a>00321 
<a name="l00335"></a><a class="code" href="structiCelGameServer.html">00335</a> <span class="keyword">struct </span><a class="code" href="structiCelGameServer.html" title="The main object to manage the server game logic.">iCelGameServer</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00336"></a>00336 {
<a name="l00337"></a>00337   SCF_INTERFACE (<a class="code" href="structiCelGameServer.html" title="The main object to manage the server game logic.">iCelGameServer</a>, 1, 0, 0);
<a name="l00338"></a>00338 
<a name="l00343"></a>00343   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameServer.html#a6cb6d3fd0f3820db6a4c84008f1684f5" title="Register the manager of this server.">RegisterServerManager</a> (<a class="code" href="classcelGameServerManager.html" title="This is an interface you should implement in order to manage the events from the server.">celGameServerManager</a>* manager) = 0;
<a name="l00344"></a>00344 
<a name="l00349"></a>00349   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameServer.html#a1eaa5e8aa5701e68c38b47d7c957ce7d" title="Set the administrator of the game.">SetAdministrator</a> (<a class="code" href="classcelPlayer.html" title="General information on a player.">celPlayer</a>* new_admin) = 0;
<a name="l00350"></a>00350 
<a name="l00355"></a>00355   <span class="keyword">virtual</span> <a class="code" href="classcelPlayer.html" title="General information on a player.">celPlayer</a>* <a class="code" href="structiCelGameServer.html#a2b1eec275a973437b25f4194df7afca3" title="Return the administrator of the game.">GetAdministrator</a> () = 0;
<a name="l00356"></a>00356 
<a name="l00360"></a>00360   <span class="keyword">virtual</span> <a class="code" href="structiCelPlayerList.html" title="A list of players.">iCelPlayerList</a>* <a class="code" href="structiCelGameServer.html#ac664ae438691d8e81ab1eca933ac8ddf" title="Return the list of players connected to the server.">GetPlayerList</a> () = 0;
<a name="l00361"></a>00361 
<a name="l00365"></a>00365   <span class="keyword">virtual</span> celPlayerNetworkState <a class="code" href="structiCelGameServer.html#a1fdd2b3ad82217d20ff4ab1e32e9ae00" title="Return the state of the network connection to the player.">GetPlayerState</a> (<a class="code" href="classcelPlayer.html" title="General information on a player.">celPlayer</a>* player) = 0;
<a name="l00366"></a>00366 
<a name="l00372"></a>00372   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameServer.html#afbad5b793a8dfffbb3a804cdb61003de" title="Kick the player from the game, ie the player will be forced to disconnect from the game...">KickPlayer</a> (<a class="code" href="classcelPlayer.html" title="General information on a player.">celPlayer</a>* player, <span class="keyword">const</span> <span class="keywordtype">char</span>* reason) = 0;
<a name="l00373"></a>00373 
<a name="l00381"></a>00381   <span class="keyword">virtual</span> <a class="code" href="structiCelPlayerList.html" title="A list of players.">iCelPlayerList</a>* <a class="code" href="structiCelGameServer.html#ad9f84d3748644041a79a77ffc52b0101" title="Create a channel, ie a list of players.">CreateChannel</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> channel_id) = 0;
<a name="l00382"></a>00382 
<a name="l00387"></a>00387   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameServer.html#a45b7b85b7722f300a32a8e4c7f356bf6" title="Stop managing the list of players and delete it.">RemoveChannel</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> channel_id) = 0;
<a name="l00388"></a>00388 
<a name="l00392"></a>00392   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameServer.html#ab365defd0d72ed26bc9feca9c2eb2d24" title="A server event has to be sent to a player.">LaunchServerEvent</a> (<a class="code" href="classcelPlayer.html" title="General information on a player.">celPlayer</a>* player, 
<a name="l00393"></a>00393         <a class="code" href="classcelServerEventData.html" title="The data about a server event.">celServerEventData</a> &amp;event_data) = 0;
<a name="l00394"></a>00394 
<a name="l00398"></a>00398   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameServer.html#ab365defd0d72ed26bc9feca9c2eb2d24" title="A server event has to be sent to a player.">LaunchServerEvent</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> channel_id, 
<a name="l00399"></a>00399         <a class="code" href="classcelServerEventData.html" title="The data about a server event.">celServerEventData</a> &amp;event_data) = 0;
<a name="l00400"></a>00400 
<a name="l00417"></a>00417   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameServer.html#aedb3d272861232091c72158d8caeeed7" title="Establish a link between an entity and a player.">SetNetworkLink</a> (<a class="code" href="classcelPlayer.html" title="General information on a player.">celPlayer</a>* player, 
<a name="l00418"></a>00418         <a class="code" href="classcelNetworkLinkData.html" title="The data about a network link.">celNetworkLinkData</a> &amp;link_data, <span class="keywordtype">bool</span> player_controlled) = 0;
<a name="l00419"></a>00419 
<a name="l00429"></a>00429   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameServer.html#a2226fe2e45a5ed5218fe1902cdf0952c" title="Define if it is the client or the server that will update the entity.">ChangeLinkControl</a> (<a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* entity, <a class="code" href="classcelPlayer.html" title="General information on a player.">celPlayer</a>* player, 
<a name="l00430"></a>00430         <span class="keywordtype">bool</span> player_controlled) = 0;
<a name="l00431"></a>00431 
<a name="l00442"></a>00442   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameServer.html#aedb3d272861232091c72158d8caeeed7" title="Establish a link between an entity and a player.">SetNetworkLink</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> channel_id, 
<a name="l00443"></a>00443         <a class="code" href="classcelNetworkLinkData.html" title="The data about a network link.">celNetworkLinkData</a> &amp;link_data) = 0;
<a name="l00444"></a>00444 
<a name="l00449"></a>00449   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameServer.html#ae44a50920a02a43fc35ebaa31d9dfed7" title="Remove the existing link between the entity and the player, ie the state of the entity will no more b...">RemoveNetworkLink</a> (<a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* entity, <a class="code" href="classcelPlayer.html" title="General information on a player.">celPlayer</a>* player) = 0;
<a name="l00450"></a>00450 
<a name="l00455"></a>00455   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameServer.html#ae44a50920a02a43fc35ebaa31d9dfed7" title="Remove the existing link between the entity and the player, ie the state of the entity will no more b...">RemoveNetworkLink</a> (<a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* entity,
<a name="l00456"></a>00456         <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> channel_id) = 0;
<a name="l00457"></a>00457 
<a name="l00465"></a>00465   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameServer.html#a85aee2cd64948525a312287aca56cc7e" title="Level change, the game is re-initialized.">ChangeLevel</a> (<a class="code" href="classcelGameInfo.html" title="General information on a game.">celGameInfo</a>* new_game) = 0;
<a name="l00466"></a>00466 
<a name="l00472"></a>00472   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameServer.html#a4340ef99e77de2b0339700d4405c50dc" title="Specify the maximum frequency at which the server can send data to clients.">SetNetworkPeriod</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> period) = 0;
<a name="l00473"></a>00473 
<a name="l00478"></a>00478   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameServer.html#ac7ca31a371cadb9d58aa1f4cd0881c30" title="Specify the maximum bandwidth of the network data transmission in bytes per second.">SetMaximumBandwidth</a> (<span class="keywordtype">size_t</span> width) = 0;
<a name="l00479"></a>00479 
<a name="l00485"></a>00485   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameServer.html#a6c28d9004097fe7023cd4af82a10e213" title="The server will consider a client connected until the connection is broken (network state CEL_NET_PLA...">SetClientTimeOut</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> timeout) = 0;
<a name="l00486"></a>00486 
<a name="l00490"></a>00490   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameServer.html#a48175bcad72165ff0d472a12bdad91e0" title="Return the network stats of the specified player.">GetNetworkPlayerStats</a> (<a class="code" href="classcelPlayer.html" title="General information on a player.">celPlayer</a>* player, 
<a name="l00491"></a>00491         <a class="code" href="structcelNetworkPlayerStats.html" title="The network stats of the connection viewed by the server.">celNetworkPlayerStats</a>&amp; stats) <span class="keyword">const</span> = 0;
<a name="l00492"></a>00492 
<a name="l00496"></a>00496   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameServer.html#af65fd31e91d224e8a7f1d031b0248f0a" title="Return the network stats of this server.">GetNetworkTotalStats</a> (
<a name="l00497"></a>00497         <a class="code" href="structcelNetworkPlayerTotalStats.html" title="The network stats of the connection of all the players viewed by the server.">celNetworkPlayerTotalStats</a>&amp; stats) <span class="keyword">const</span> = 0;
<a name="l00498"></a>00498 };
<a name="l00499"></a>00499 
<a name="l00512"></a><a class="code" href="structiCelGameClient.html">00512</a> <span class="keyword">struct </span><a class="code" href="structiCelGameClient.html" title="The main object to manage the client game logic.">iCelGameClient</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00513"></a>00513 {
<a name="l00514"></a>00514   SCF_INTERFACE (<a class="code" href="structiCelGameClient.html" title="The main object to manage the client game logic.">iCelGameClient</a>, 0, 0, 1);
<a name="l00515"></a>00515 
<a name="l00520"></a>00520   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameClient.html#ac711d59e3017062fe6524664eb608290" title="Register the manager of this client.">RegisterClientManager</a> (<a class="code" href="classcelGameClientManager.html" title="This is an interface you should implement in order to manage the events from the client.">celGameClientManager</a>* manager) = 0;
<a name="l00521"></a>00521 
<a name="l00525"></a>00525   <span class="keyword">virtual</span> <a class="code" href="classcelPlayer.html" title="General information on a player.">celPlayer</a>* <a class="code" href="structiCelGameClient.html#a53e07ebfff959587f343f488306bceda" title="Return the current player associated with this client.">GetPlayer</a> () = 0;
<a name="l00526"></a>00526 
<a name="l00532"></a>00532   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameClient.html#a89bc1a1269e364572b58d434b90a2ecd" title="Update the data of the current player.">UpdatePlayer</a> (<a class="code" href="classcelPlayer.html" title="General information on a player.">celPlayer</a>* player) = 0;
<a name="l00533"></a>00533 
<a name="l00537"></a>00537   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> <a class="code" href="structiCelGameClient.html#aca67c50f3709d839171e405a31aa8918" title="Convert a time from the server clock to the client clock.">ConvertServerClock</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> server_time) <span class="keyword">const</span> = 0;
<a name="l00538"></a>00538 
<a name="l00543"></a>00543   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga91ad9478d81a7aaf2593e8d9c3d06a14">uint</a> <a class="code" href="structiCelGameClient.html#ab1174ab40fc358ddcf9f2ae6099df749" title="Return the ID of the entity on the client side that is network linked with an entity with ID entity_i...">GetMappedID</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga91ad9478d81a7aaf2593e8d9c3d06a14">uint</a> entity_id) <span class="keyword">const</span> = 0;
<a name="l00544"></a>00544 
<a name="l00549"></a>00549   <span class="keyword">virtual</span> <a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* <a class="code" href="structiCelGameClient.html#a34d610d547dfa9cea731f808d017145e" title="Return the entity on the client side that is network linked with an entity with ID entity_id on the s...">GetMappedEntity</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga91ad9478d81a7aaf2593e8d9c3d06a14">uint</a> entity_id) <span class="keyword">const</span> = 0;
<a name="l00550"></a>00550 
<a name="l00554"></a>00554   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameClient.html#abbd38fbb4892af3680c5a78ed67204c3" title="Indicate that the client has loaded everything and is ready to play.">SetReady</a> () = 0;
<a name="l00555"></a>00555 
<a name="l00559"></a>00559   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameClient.html#a5b931754075fb1eae48e6cbc4ef5cbd0" title="Ask the game client to send an event to the server.">LaunchClientEvent</a> (<a class="code" href="classcelClientEventData.html" title="The data about a client event.">celClientEventData</a> &amp;event_data) = 0;
<a name="l00560"></a>00560 
<a name="l00564"></a>00564   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameClient.html#acbca219321e1c5d3293917dd4f1c50e1" title="Specify the maximum frequency at which the client can send data.">SetNetworkPeriod</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> period) = 0;
<a name="l00565"></a>00565 
<a name="l00570"></a>00570   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameClient.html#a1dabc15bda68c4ce7b34466abfa8a327" title="The maximum bandwidth of the network data transmission in bytes per second.">SetMaximumBandwidth</a> (<span class="keywordtype">size_t</span> width) = 0;
<a name="l00571"></a>00571 
<a name="l00576"></a>00576   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameClient.html#aedceff04188a52a3cc1290a985f4bc88" title="The client will consider itself connected to the server until the connection is broken during specifi...">SetServerTimeOut</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> timeout) = 0;
<a name="l00577"></a>00577 
<a name="l00581"></a>00581   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelGameClient.html#a9f7e81fb02d8477658d040988c913770" title="Return the network stats of this client.">GetNetworkStats</a> (<a class="code" href="structcelNetworkServerStats.html" title="The network stats of the connection viewed by the client.">celNetworkServerStats</a>&amp; stats) <span class="keyword">const</span> = 0;
<a name="l00582"></a>00582 };
<a name="l00583"></a>00583 
<a name="l00595"></a><a class="code" href="classcelGameServerManager.html">00595</a> <span class="keyword">class </span><a class="code" href="classcelGameServerManager.html" title="This is an interface you should implement in order to manage the events from the server.">celGameServerManager</a>
<a name="l00596"></a>00596 {
<a name="l00597"></a>00597  <span class="keyword">public</span>:
<a name="l00598"></a>00598   <span class="keyword">virtual</span> ~<a class="code" href="classcelGameServerManager.html" title="This is an interface you should implement in order to manage the events from the server.">celGameServerManager</a> () {};
<a name="l00599"></a>00599 
<a name="l00606"></a>00606   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classcelGameServerManager.html#a7099380d2f41b043f3ae2c513cc1a0b2" title="A player is asking to join the game.">AuthorizePlayer</a> (<a class="code" href="classcelPlayer.html" title="General information on a player.">celPlayer</a>* player, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a>&amp; reason) = 0;
<a name="l00607"></a>00607 
<a name="l00613"></a>00613   <span class="keyword">virtual</span> <a class="code" href="classcelPlayer.html" title="General information on a player.">celPlayer</a>* <a class="code" href="classcelGameServerManager.html#a67efb888c26193128c48a1887b5e45ee" title="Check if the new data of a player are valid.">ValidatePlayerUpdate</a> (<a class="code" href="classcelPlayer.html" title="General information on a player.">celPlayer</a>* previous_player_data) = 0;
<a name="l00614"></a>00614 
<a name="l00618"></a>00618   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classcelGameServerManager.html#ac631853c4262d0e20da841e5a9dc832c" title="The state of the network connection to the player has changed.">PlayerNetworkStateChanged</a> (<a class="code" href="classcelPlayer.html" title="General information on a player.">celPlayer</a>* player, 
<a name="l00619"></a>00619         celPlayerNetworkState new_state, 
<a name="l00620"></a>00620         celPlayerNetworkState previous_state) = 0;
<a name="l00621"></a>00621 
<a name="l00625"></a>00625   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classcelGameServerManager.html#a5bbf3b77ea631e94e5f8c1fccb97e4db" title="A client event has been catched.">HandleClientEvent</a> (<a class="code" href="classcelPlayer.html" title="General information on a player.">celPlayer</a>* player, 
<a name="l00626"></a>00626         celClientEventType event_type, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> event_time, 
<a name="l00627"></a>00627         <a class="code" href="structiCelDataBuffer.html" title="This interface describes persistable data.">iCelDataBuffer</a>* event_data) = 0;
<a name="l00628"></a>00628 
<a name="l00637"></a>00637   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classcelGameServerManager.html#a1bd1f5db329bf4f59b10ee3ef6835491" title="An entity is controlled by a player and a problem was encountered while updating the data of this ent...">PersistenceProblem</a> (<a class="code" href="classcelPlayer.html" title="General information on a player.">celPlayer</a>* player, <a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* entity,
<a name="l00638"></a>00638         <a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>* pc, celPersistenceResult persist_code) = 0;
<a name="l00639"></a>00639 
<a name="l00644"></a>00644   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classcelGameServerManager.html#a1b6f49c05e21921c0b669c1c4f1fdf08" title="The game is finished and the server will be closed.">ServerEnd</a> () = 0;
<a name="l00645"></a>00645 };
<a name="l00646"></a>00646 
<a name="l00657"></a><a class="code" href="classcelGameClientManager.html">00657</a> <span class="keyword">class </span><a class="code" href="classcelGameClientManager.html" title="This is an interface you should implement in order to manage the events from the client.">celGameClientManager</a>
<a name="l00658"></a>00658 {
<a name="l00659"></a>00659  <span class="keyword">public</span>:
<a name="l00660"></a>00660   <span class="keyword">virtual</span> ~<a class="code" href="classcelGameClientManager.html" title="This is an interface you should implement in order to manage the events from the client.">celGameClientManager</a> () {};
<a name="l00661"></a>00661 
<a name="l00665"></a>00665   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classcelGameClientManager.html#a8527af0860e7ecdef1053f7db9d4dd32" title="The data of the player has been validated by the server.">PlayerValidated</a> (<a class="code" href="classcelPlayer.html" title="General information on a player.">celPlayer</a>* player) = 0;
<a name="l00666"></a>00666 
<a name="l00670"></a>00670   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classcelGameClientManager.html#a968634071bd19f2e641947140b4ce3c8" title="A server event has been catched.">HandleServerEvent</a> (celServerEventType event_type, 
<a name="l00671"></a>00671         <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> event_time, <a class="code" href="structiCelDataBuffer.html" title="This interface describes persistable data.">iCelDataBuffer</a>* event_data) = 0;
<a name="l00672"></a>00672 
<a name="l00688"></a>00688   <span class="keyword">virtual</span> <a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* <a class="code" href="classcelGameClientManager.html#a5ebea8bf343b566d6817aabf566bf621" title="A network link has been set up on the server side between a server entity and this client...">CreateNetworkLinkTarget</a> (celNetworkLinkType link_type, 
<a name="l00689"></a>00689         <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> creation_time, <a class="code" href="structiCelPersistentDataList.html" title="A list of persistent data for all the property classes of an entity.">iCelPersistentDataList</a>* creation_data, 
<a name="l00690"></a>00690         <span class="keywordtype">bool</span> player_controlled) = 0;
<a name="l00691"></a>00691 
<a name="l00705"></a>00705   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classcelGameClientManager.html#a1a42f602531b4a95ff887f11058ea677" title="There is a change in the way the entity is controlled, ie if it is controlled by the client or by the...">NetworkLinkControlChanged</a> (<a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* entity, 
<a name="l00706"></a>00706         <span class="keywordtype">bool</span> player_controlled) = 0;
<a name="l00707"></a>00707 
<a name="l00712"></a>00712   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classcelGameClientManager.html#aa5b2a07488d63ffc26c7c401381a3ea6" title="The network link to the specified entity is closing.">NetworkLinkRemoved</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> deletion_time,
<a name="l00713"></a>00713         <a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* entity) = 0;
<a name="l00714"></a>00714 
<a name="l00719"></a>00719   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classcelGameClientManager.html#a237ee6c3a3904eafd3d021f06558ee4b" title="The level has changed.">LevelChanged</a> (<a class="code" href="classcelGameInfo.html" title="General information on a game.">celGameInfo</a>* new_game) = 0;
<a name="l00720"></a>00720 
<a name="l00725"></a>00725   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classcelGameClientManager.html#abd024e8b9617a69d068aacd9c343f8e6" title="The client will be closed.">ClientEnd</a> () = 0;
<a name="l00726"></a>00726 };
<a name="l00727"></a>00727 
<a name="l00728"></a>00728 <span class="preprocessor">#endif // __CEL_PL_NETWORK__</span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
